/*
 ķ
   Program..: _DCCOLOR.PRG                           
   Author...: Roger J. Donnay                        
   Notice...: (c) DONNAY Software Designs 1987-1998  
   Date.....: Apr 18, 1998                           
   Notes....: Color system                           
                                                     
   Functions:  dc_clrarr(), dc_color, dc_colormode() 
            :  dc_color2array(), dc_attrtoa()        
            :  dc_atoattr(), dc_colorini()           
            :  dc_roloc(), dc_color2gra()            
            :  dc_setcolor, dc_colorlist()           
 Ľ
*/

#include 'dccolor.ch'
#include 'set.ch'
#include 'gra.ch'
#INCLUDE "dcdialog.CH"
#INCLUDE "dcgra.CH"
#include "dcmsg.ch"

#DEFINE nCOLOR_RED_FG        aRGB[1]
#DEFINE nCOLOR_GREEN_FG      aRGB[2]
#DEFINE nCOLOR_BLUE_FG       aRGB[3]
#DEFINE nCOLOR_RED_BG        aRGB[4]
#DEFINE nCOLOR_GREEN_BG      aRGB[5]
#DEFINE nCOLOR_BLUE_BG       aRGB[6]
#DEFINE oCOLOR_RED_FG        aRGB[7]
#DEFINE oCOLOR_GREEN_FG      aRGB[8]
#DEFINE oCOLOR_BLUE_FG       aRGB[9]
#DEFINE oCOLOR_RED_BG        aRGB[10]
#DEFINE oCOLOR_GREEN_BG      aRGB[11]
#DEFINE oCOLOR_BLUE_BG       aRGB[12]
#DEFINE oCOLOR_RGB           aRGB[13]
#DEFINE lCOLOR_FOREGROUND    aRGB[14]


MEMVAR dCLIP, dCCOLOR
STATIC lColorMon := .t.

* -------------------*

FUNCTION dc_color ( cColorString,  lSelectBar, lReverseVideo )

IF VALTYPE( cColorString ) = 'N'
  IF cColorString < 100
    cColorString := dCCOLOR[dCCOLOR[1]+1,cColorString]
  ELSE
    cColorString := cC_EXPBOXC+','+cC_CURRGET+',,,'+cC_PENDGET
  ENDIF
ELSE
  cColorString := IIF(VALTYPE(cColorString)='C',cColorString,'')
ENDIF
lSelectBar := IIF(VALTYPE(lSelectBar)='L',lSelectBar,.F.)
lReverseVideo := IIF(VALTYPE(lReverseVideo)='L',lReverseVideo,.F.)

IF ISCOLOR() .AND. lColorMon
  SET COLOR TO (cColorString)
ELSE
  IF lSelectBar
    IF lReverseVideo
      SETCOLOR('W/N,N/W,N,N,N/W')
    ELSE
      SETCOLOR('N/W,N/W,N,N,N/W')
    ENDIF
  ELSE
    IF lReverseVideo
      SETCOLOR('W/N,W/N,N,N,W/N')
    ELSE
      SET COLOR TO
    ENDIF
  ENDIF
ENDIF
RETURN SETCOLOR()

// ----------------- //

FUNCTION dc_colormode ( lMode )
LOCAL lOldColor := lColorMon
lColorMon := IIF(VALTYPE(lMode)='L',lMode,lColorMon)
RETURN lOldColor

// ----------------- //

FUNCTION dc_color2array ( cColor )
LOCAL nPointer := 1, cString := '', aColor := {}, cChar
cColor := IIF(Valtype(cColor)='C',cColor,SETCOLOR())
FOR nPointer := 1 TO LEN(cColor)+1
  cChar := SUBSTR( cColor, nPointer, 1 )
  IF cChar = ',' .OR. nPointer = LEN(cColor)+1
    AADD( aColor, cString )
    cString := ''
  ELSE
    cString += cChar
  ENDIF
NEXT
RETURN aColor

// ----------------- //

FUNCTION dc_clrarr( lUpdate )

LOCAL  dDefaultDir, cIniFile, nColorCount, nArrayCount, ;
       oAppWindow := SetAppWindow()

M->dCCOLOR := { 0, {} }

RETURN .t.

lUpdate := IIF(VALTYPE(lUpdate)='L',lUpdate,.f.)
IF TYPE('M->dCCOLOR')='A' .AND. !lUpdate
  RETURN .T.
ENDIF
dDefaultDir := SET(_SET_DEFAULT)
SET DEFA TO
PUBLIC dCCOLOR
IF TYPE('M->dCCOLOR') # 'A'
  dCCOLOR := { 0, {} }
ENDIF
IF FCLOSE(FOPEN( _D_C_CDNAM('DCCOLOR.INI')))
  DC_ColorIni(.f., _D_C_CDNAM('DCCOLOR.INI') )
  dCCOLOR[1] := 1
ENDIF
IF dCCOLOR[1] = 0
  dCCOLOR[1] := 1
ENDIF
IF LEN(dCCOLOR[2]) = 0
  dCCOLOR[1] := 1
  _DCColorDefault(1)
ENDIF

IF !lC_BLINKBIT .AND. Valtype(oAppWindow) = 'O' .AND. oAppWindow:isderivedFrom('XBPCRT')
  SetBlink( .f. )
ENDIF
SET DEFA TO (dDefaultDir)
IF lUpdate
  DC_DO('DC_CLRSETUP(.T.)')
ENDIF
RETURN .t.

/* ----------------- */

INIT PROC _dccolorinit

SET WRAP ON
DC_ClrArr()
RETURN

/* ----------------- */

FUNCTION DC_Attrtoa ( nColor )

LOCAL nForeColor, nBackColor, cForeColor, cBackColor

nColor := IIF(Valtype(nColor)='N',nColor,0)
nForeColor := DC_ANDBITS(nColor,15)
nBackColor := DC_ANDBITS(nColor,240)/16

IF DC_ANDBITS( nForeColor, 7 ) = 7
  cForeColor := 'W'
ELSE
  cForeColor := "" + IIF(DC_ANDBITS( nForeColor, 1) > 0,"B","" )
  cForeColor := cForeColor + IIF(DC_ANDBITS( nForeColor, 2) > 0,"G","" )
  cForeColor := cForeColor + IIF(DC_ANDBITS( nForeColor, 4) > 0,"R","" )
  IF EMPTY(cForeColor)
    cForeColor := 'N'
  ENDIF
ENDIF
IF DC_ANDBITS( nBackColor, 7 ) = 7
  cBackColor := 'W'
ELSE
  cBackColor := "" + IIF(DC_ANDBITS( nBackColor, 1) > 0,"B","" )
  cBackColor := cBackColor + IIF(DC_ANDBITS( nBackColor, 2) > 0,"G","" )
  cBackColor := cBackColor + IIF(DC_ANDBITS( nBackColor, 4) > 0,"R","" )
  IF EMPTY(cBackColor)
    cBackColor := 'N'
  ENDIF
ENDIF
RETURN cForeColor + IIF(nForeColor>7,'+','') + ;
                    IIF(nBackColor>7,'*','') + '/' + cBackColor

/* ------------------- */

FUNCTION DC_AtoAttr ( cColor )

LOCAL nForeColor := 0, nBackColor := 0, cForeColor, cBackColor,;
      nDivisor, nAttr := 0

cColor := IIF(Valtype(cColor)='C',UPPER(cColor),'')
nDivisor := AT('/',cColor)
IF nDivisor > 0
  cForeColor := SUBSTR( cColor,1,nDivisor-1)
ELSE
  cForeColor := cColor
ENDIF
IF nDivisor > 0
  cBackColor := SUBSTR( cColor,nDivisor+1 )
ELSE
  cBackColor := ''
ENDIF
IF 'N' $ cForeColor
ELSEIF 'W' $ cForeColor
  nAttr := 7
ELSE
  IF 'B' $ cForeColor
    nAttr := 1
  ENDIF
  IF 'G' $ cForeColor
    nAttr += 2
  ENDIF
  IF 'R' $ cForeColor
    nAttr += 4
  ENDIF
ENDIF
IF '+' $ cForeColor
  nAttr += 8
ENDIF
IF 'N' $ cBackColor
ELSEIF 'W' $ cBackColor
  nAttr += 112
ELSE
  IF 'B' $ cBackColor
    nAttr += 16
  ENDIF
  IF 'G' $ cBackColor
    nAttr += 32
  ENDIF
  IF 'R' $ cBackColor
    nAttr += 64
  ENDIF
ENDIF
IF '*' $ cColor
  nAttr += 128
ENDIF
RETURN nAttr

/* -------------------- */

FUNCTION DC_Roloc ( nAttr, cColor )

LOCAL cForeColor, cBackColor
cColor := DC_AttrToA( nAttr )
cForeColor := SubStr(cColor,AT('/',cColor)+1)
cBackColor := Substr(cColor,1,AT('/',cColor)-1)
IF !SetBlink()
  cForeColor := StrTran(cForeColor,'*','+')
ENDIF
cBackColor := StrTran(cBackColor,'+','*')
cColor := cForeColor + '/' + cBackColor
RETURN DC_AtoAttr( cColor )

/* -------------------- */

FUNCTION DC_ColorIni ( lSave, cFileName )

STATIC cIniFile
LOCAL i, cColorSet, aColorSet := { dCCOLOR[1] }

IF !Empty(cFileName)
  cIniFile := cFileName
ELSEIF Empty(cIniFile)
  cIniFile := 'DCCOLOR.INI'
ENDIF
lSave := IIF(Valtype(lSave)='L',lSave,.f.)
IF lSave
  DC_IniSave( cIniFile, '[COLORSET]', aColorSet, {'ColorSet'} )
  FOR i := 2 TO LEN(dCCOLOR)
    cColorSet := '[COLORSET_'+AllTrim(Str(i-1))+']'
    IF EMPTY(dCCOLOR[i])
      _DCColorDefault(i-1)
    ENDIF
    DC_IniSave( cIniFile, cColorSet, dCCOLOR[i], _DCColorIni() )
  NEXT
ELSE
  DC_IniLoad( cIniFile, '[COLORSET]', aColorSet, {'ColorSet'} )
  FOR i := 2 TO 10
    ASIZE(dCCOLOR,i)
    cColorSet := '[COLORSET_'+AllTrim(Str(i-1))+']'
    _DCColorDefault(i-1)
    IF !DC_IniLoad( cIniFile, cColorSet, dCCOLOR[i], _DCColorIni() )
      ASIZE(dCCOLOR,i-1)
      EXIT
    ENDIF
  NEXT
  IF aColorSet[1] > 0 .AND. aColorSet[1] < LEN(dCCOLOR)
    dCCOLOR[1] := aColorSet[1]
  ENDIF
ENDIF
RETURN nil

/* -------------------- */

STATIC FUNCTION _DCColorIni()

RETURN { ;
     cINI_DOTPROMPT,;
     cINI_BRMENUF,;
     cINI_BRMENUD,;
     cINI_BRMENUH,;
     cINI_BRMENUB,;
     cINI_BRMENUS,;
     cINI_POPMENF,;
     cINI_POPMENI,;
     cINI_POPMENS,;
     cINI_MEMOBOX,;
     cINI_MEMOTXT,;
     cINI_EXPBOXF,;
     cINI_EXPBOXC,;
     cINI_DBUGGER,;
     cINI_WARNBOX,;
     cINI_WARNTXT,;
     cINI_DBUGBOX,;
     cINI_DBUGTXT,;
     cINI_DBUGBAR,;
     '',;
     cINI_SAY,;
     cINI_PENDGET,;
     cINI_CURRGET,;
     cINI_STAT1,;
     cINI_STAT2,;
     cINI_POPGRAY,;
     cINI_MEMOEDIT,;
     cINI_MEMOMENU,;
     cINI_MEMOHILIT,;
     cINI_BUTTON,;
     cINI_BRMENUKU,;
     cINI_BRMENUKS,;
     cINI_PROGRESS,;
     cINI_BLINKBIT,;
     cINI_SETNAME,;
     '',;
     '' }

/* -------------------- */

STATIC PROCEDURE _dccolordefault ( nColorSet )

LOCAL nSaveSet := dCCOLOR[1]

dCCOLOR[1] := nColorSet
dCCOLOR[nColorSet+1] := Array(37)
AFILL( dCCOLOR[nColorSet+1], '')
cC_DOTPROMPT := "GR+/N*"           // Main screen
cC_BRMENUF   := "N+/W"             // Browse menus frame
cC_BRMENUD   := "N/W"              // Browse menus data
cC_BRMENUH   := "W+/RB"            // Browse menus header
cC_BRMENUB   := "N/BG,W+/BG"       // Browse menus menu bar
cC_BRMENUS   := "GR+/R"            // Browse menus select bar
cC_BRMENUKU  := "W+/B"             // Browse menus Unselected Key Column
cC_BRMENUKS  := "W+/R"             // Browse menus Selected Key Column
cC_POPMENF   := "N/BG"             // Popup / pulldown menu frames
cC_POPMENI   := "N/BG,W+/BG"       // Popup / pulldown menu items
cC_POPMENS   := "N/W"              // Popup / pulldown menu select bars
cC_POPGRAY   := "N+/BG"            // Popup / pulldown grayed items
cC_MEMOBOX   := "N/W"              // memos box
cC_MEMOTXT   := "W+/B"             // memos contents
cC_MEMOEDIT  := "W+/N"             // memos contents (edit mode)
cC_MEMOMENU  := "N/BG"             // memo menu bar
cC_MEMOHILIT := "W+/BG"            // memo menu hilite color
cC_EXPBOXF   := "B/W"              // Exploding boxes frame
cC_EXPBOXC   := "N/W"              // Exploding boxes contents
cC_DBUGGER   := "W+/R"             // DBUGGER main screen
cC_WARNBOX   := "W+/R"             // Warning boxes frame
cC_WARNTXT   := "GR+/R"            // Warning boxes contents
cC_DBUGBOX   := "N/W"              // Debug boxes frames
cC_DBUGTXT   := "B/W"              // Debug boxes contents
cC_DBUGBAR   := "W+/B"             // Debug boxes select bar
cC_SPECIAL   := chr(112)+chr(31)   // Special codes
cC_SAY       := "W/B"              // SAYs
cC_PENDGET   := "N/BG"             // Pending GETs
cC_CURRGET   := "GR+/R"            // Current GET
cC_BUTTON    := 'N/BG'             // DC_ReadBox() dialog button color
cC_STAT1     := "N+/W"              // Status line lines
cC_STAT2     := "N/W"              // Status line data
cC_SETNAME   := 'Standard Color Set'
lC_BLINKBIT  := .f.               // Blink = .t., High Intensity = .f.
cC_PROGRESS  := 'W/B,W/B'         // Progress Bars
dCCOLOR[1] := nSaveSet
RETURN

/* ----------------- */

FUNCTION dc_color2gra ( cColor )

LOCAL nAt, nColor, i, cForeColor, cBackColor, aColor

cColor := IIF(Valtype(cColor)='C',cColor,SetColor())
nAt := AT(',',cColor)
IF nAt > 0
  cColor := Substr(cColor,1,nAt-1)
ENDIF

nAt := AT('/',cColor)
IF nAt > 0
  cForeColor := Substr(cColor,1,nAt-1)
  cBackColor := Substr(cColor,nAt+1)
ELSE
  cForeColor := cColor
  cBackColor := 'N'
ENDIF

aColor := {0,0}

FOR i := 1 TO 2

  IF i = 1
    cColor := cForeColor
  ELSE
    cColor := cBackColor
  ENDIF

  DO CASE

    CASE cColor = 'B'
      nColor := GRA_CLR_BLUE

    CASE cColor = 'B+'
      nColor := GRA_CLR_DARKBLUE

    CASE cColor = 'R'
      nColor := GRA_CLR_RED

    CASE cColor = 'R+'
      nColor := GRA_CLR_DARKRED

    CASE cColor = 'G'
      nColor := GRA_CLR_GREEN

    CASE cColor = 'G+'
      nColor := GRA_CLR_DARKGREEN

    CASE cColor = 'GR'
      nColor := GRA_CLR_BROWN

    CASE cColor = 'GR+'
      nColor := GRA_CLR_YELLOW

    CASE cColor = 'N'
      nColor := GRA_CLR_BLACK

    CASE cColor = 'N+'
      nColor := GRA_CLR_DARKGRAY

    CASE cColor = 'RB'
      nColor := GRA_CLR_PINK

    CASE cColor = 'RB'
      nColor := GRA_CLR_DARKPINK

    CASE cColor = 'BG'
      nColor := GRA_CLR_CYAN

    CASE cColor = 'BG+'
      nColor := GRA_CLR_DARKCYAN

    OTHERWISE
      nColor := 0

  ENDCASE

  aColor[i] := nColor

NEXT
RETURN aColor

/* ----------------- */

FUNCTION dc_gra2color ( aColor )

LOCAL aColors, cColor

IF Valtype(aColor) $ 'CU'
  RETURN aColor
ENDIF

IF Valtype( aColor ) # 'A'
  aColor := {}
ENDIF
ASize( aColor, 2 )

DC_ColorList( nil, nil, @aColors )

cColor := ''
IF Valtype(aColor[1]) = 'N' .AND. aColor[1] >= -5 .AND. aColor[1] <= 15
  cColor += aColors[aColor[1]+6,3]
  IF Valtype(aColor[2]) = 'N' .AND. aColor[2] >= -5 .AND. aColor[2] <= 15
    cColor += '/' + aColors[aColor[2]+6,3]
  ENDIF
ELSEIF Valtype(aColor[1]) = 'C'
  cColor := aColor[1]
ENDIF

RETURN cColor

/* -------------------- */

FUNCTION DC_SetColor ( cColor )

IF !DC_Gui()
  RETURN SetColor( cColor )
ENDIF
RETURN ''

/* -------------------- */

FUNCTION DC_ColorList ( nType, aColorTypes, aColors )

LOCAL cColor, i, cType

aColors := { ;
   { GRA_CLR_FALSE,      'False',        'TRUE' },;
   { GRA_CLR_TRUE,       'True',         'FALSE' },;
   { GRA_CLR_DEFAULT,    'Default',      'DEFAULT' },;
   { GRA_CLR_BACKGROUND, 'BackGround',   'BACKGROUND' },;
   { GRA_CLR_NEUTRAL,    'Neutral',      'NEUTRAL' },;
   { GRA_CLR_WHITE,      'White',        'W+' }, ;
   { GRA_CLR_BLACK,      'Black',        'N' },;
   { GRA_CLR_BLUE,       'Blue',         'B+' },;
   { GRA_CLR_RED,        'Red',          'R+' },;
   { GRA_CLR_PINK,       'Pink',         'RB+' },;
   { GRA_CLR_GREEN,      'Green',        'G+' },;
   { GRA_CLR_CYAN,       'Cyan',         'BG' },;
   { GRA_CLR_YELLOW,     'Yellow',       'GR+' },;
   { GRA_CLR_DARKGRAY,   'Dark Gray',    'N+' },;
   { GRA_CLR_DARKBLUE,   'Dark Blue',     'B' },;
   { GRA_CLR_DARKRED,    'Dark Red',     'R' },;
   { GRA_CLR_DARKPINK,   'Dark Pink',    'RB' },;
   { GRA_CLR_DARKGREEN,  'Dark Green',   'G' },;
   { GRA_CLR_DARKCYAN,   'Dark Cyan',    'BG' },;
   { GRA_CLR_BROWN,      'Brown',        'GR' },;
   { GRA_CLR_PALEGRAY,   'Pale Gray',    'W' } }

aColorTypes := {}
IF Valtype(nType) = 'C'
  nType := Val(Substr(nType,1,2))
ENDIF

cColor := Space(20)
FOR i := 1 TO Len(aColors)
  cType := Str( aColors[i,1], 2 ) + ' - ' + Pad(aColors[i,2],30)
  IF Valtype(nType) = 'N' .AND. nType == aColors[i,1]
    cColor := cType
  ENDIF
  AADD( aColorTypes, cType )
NEXT
IF Valtype(nType) # 'N'
  cColor := ''
ENDIF
RETURN cColor

* ------------------

FUNCTION dc_popcolor( aColorSel, nMode, lRGB, cTitle )

LOCAL i, j, c, GetList := {}, aColor[16,16], lOk, aPres, ;
      GetOptions, oStatic, oStatic2, aRGB[15], lDown := .f., ;
      aSaveColor

DEFAULT nMode := 0, lRGB := .f.

/*
If <nMode> is 0, then DC_PopColor() is used to choose a
foreground and background color and return the choice as an
array of two numeric values.

If <nMode> is 1, then DC_PopColor() is used to choose a
foreground and background color and return the choice as a
character string in the form of a code block that can be macro
compiled and evaluated to return the 2-element array.  This is
handy for data-driven applications where the color must be stored
as a string.

If <nMode> is 2, then DC_PopColor() is used to choose a single
color and return the choice as a numeric value.
*/

DEFAULT cTitle := 'Pick a Color'

lCOLOR_FOREGROUND := .f.
IF lRGB
  IF nMode = 2
    IF Valtype(aColorSel)='A'
      IF Len(aColorSel)=2 .AND. Len(aColorSel[1])=3 .AND. Len(aColorSel[2])=3
        aSaveColor := AClone(aColorSel[2])
      ELSEIF Len(aColorSel) = 3
        aColorSel := {{0,0,0},aColorSel}
        aSaveColor := AClone(aColorSel)
      ENDIF
    ELSE
      aColorSel := {{0,0,0},{0,0,0}}
    ENDIF
  ENDIF
  nCOLOR_RED_FG   := aColorSel[1,1]
  nCOLOR_GREEN_FG := aColorSel[1,2]
  nCOLOR_BLUE_FG  := aColorSel[1,3]
  nCOLOR_RED_BG   := aColorSel[2,1]
  nCOLOR_GREEN_BG := aColorSel[2,2]
  nCOLOR_BLUE_BG  := aColorSel[2,3]
  @ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE (2*256)+1,60 ;
        OBJECT oStatic PIXEL ;
        EVAL {|o|o:lbDown := {|a,b,o|lDown:=.t.,_RGB(aRGB,1,a,b,o)}, ;
                 o:lbUp := {||lDown:=.f.}, ;
                 o:motion := {|a,b,o|IIF(lDown,_RGB(aRGB,1,a,b,o),nil)}, ;
                 o:setParent():motion := {||lDown:=.f.} }
  aColor := Array(256)

  @ 65,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE (2*256)+1,60 ;
   OBJECT oStatic2 PIXEL

  @ 0,0 DCSAY IIF(nMode#2,DC_LangMsg(DCMSG_CLR_COMPOSITE) + ' ' + ;
                          DC_LangMsg(DCMSG_CLR_COLOR),'') ;
         SAYSIZE 350,60 OBJECT oCOLOR_RGB PIXEL ;
         FONT '26.Arial Bold' ;
         PARENT oStatic2 ;
         COLOR aColorSel[1],aColorSel[2]
  IF nMode # 2
    @ 0,350 DCSAY nCOLOR_RED_FG COLOR GRA_CLR_RED PARENT oStatic2 SAYRIGHT ;
            SAYSIZE 80,20 PIXEL FONT '12.Arial Bold' OBJECT oCOLOR_RED_FG
    @20,350 DCSAY nCOLOR_GREEN_FG COLOR GRA_CLR_GREEN PARENT oStatic2 SAYRIGHT  ;
            SAYSIZE 80,20 PIXEL FONT '12.Arial Bold' OBJECT oCOLOR_GREEN_FG
    @40,350 DCSAY nCOLOR_BLUE_FG COLOR GRA_CLR_BLUE PARENT oStatic2 SAYRIGHT  ;
            SAYSIZE 80,20 PIXEL FONT '12.Arial Bold' OBJECT oCOLOR_BLUE_FG
  ENDIF
  @ 0,430 DCSAY nCOLOR_RED_BG COLOR 0,GRA_CLR_RED PARENT oStatic2 SAYRIGHT  ;
          SAYSIZE 80,20 PIXEL FONT '12.Arial Bold' OBJECT oCOLOR_RED_BG
  @20,430 DCSAY nCOLOR_GREEN_BG COLOR 0,GRA_CLR_GREEN PARENT oStatic2 SAYRIGHT  ;
          SAYSIZE 80,20 PIXEL FONT '12.Arial Bold' OBJECT oCOLOR_GREEN_BG
  @40,430 DCSAY nCOLOR_BLUE_BG COLOR 0,GRA_CLR_BLUE PARENT oStatic2 SAYRIGHT  ;
          SAYSIZE 80,20 PIXEL FONT '12.Arial Bold' OBJECT oCOLOR_BLUE_BG


ELSEIF nMode = 0 .OR. nMode = 1
  @ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE (5*16)+1,16.2 OBJECT oStatic
  FOR i := 0 TO 15
    FOR j := 0 TO 15
      aPres := { { XBP_PP_FGCLR, i } , ;
                 { XBP_PP_BGCLR, j } }
      aColor[i+1,j+1] := Pad(Alltrim(Str(i))+'/'+Alltrim(Str(j)),5)
      @ i+.1,.5+((j)*5) DCSAY aColor[i+1,j+1] FONT '6.Terminal' SAYSIZE 5 ;
        PRESENTATION aPres CARGO {i,j} ;
        PARENT oStatic ;
        EVAL {|o|o:lbDblClick := {|a,b,o|aColorSel := o:cargo[3], ;
               DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } }
    NEXT
  NEXT
ELSEIF nMode = 2
  j := 2
  @ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE (4*16)+1,1.2 OBJECT oStatic
  FOR i := 0 TO 15
    aPres := { { XBP_PP_FGCLR, i } , ;
               { XBP_PP_BGCLR, i } }
      aColor[i+1] := '   '
      @ .1,.5+((i)*4) DCSAY aColor[i+1] SAYSIZE 4 ;
        PARENT oStatic ;
        PRESENTATION aPres CARGO i ;
        EVAL {|o|o:lbDblClick := {|a,b,o|aColorSel := o:cargo[3], ;
               DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } }
  NEXT
ENDIF

IF lRGB
   @ 130,0 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_OK) SIZE 70,20 PIXEL ;
     ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}
   @ 130,90 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CANCEL) SIZE 70,20 PIXEL ;
     ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}
   IF nMode # 2
     @ 130,180 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CLR_FOREGROUND) SIZE 70,20 PIXEL ;
       ACTION {||lCOLOR_FOREGROUND := .t.,DC_GetRefresh(GetList)}
     @ 130,270 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CLR_BACKGROUND) SIZE 70,20 PIXEL ;
       ACTION {||lCOLOR_FOREGROUND := .f.,DC_GetRefresh(GetList)}
     @ 130,360 DCSAY {||Strtran(IIF( lCOLOR_FOREGROUND, ;
                        DC_LangMsg(DCMSG_CLR_FOREGROUND), ;
                        DC_LangMsg(DCMSG_CLR_BACKGROUND)) + ' ' + ;
                        DC_LangMsg(DCMSG_CLR_COLOR),'~','')} ;
       SAYSIZE 150 FONT '10.Helv Bold' PIXEL
   ENDIF
ELSE
   @ j+.5,5 DCPUSHBUTTON CAPTION DC_LangMsg(DCMSG_CANCEL) SIZE 9,1 ;
     ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)}
  @ j+.5,20 DCSAY 'Double click on a color to select' COLOR GRA_CLR_BLUE ;
     FONT '10.Helv Bold' SAYSIZE 0
ENDIF

IF Valtype(aColorSel) = 'A' .AND. Empty(aSaveColor)
  aSaveColor := AClone(aColorSel)
ENDIF

DCGETOPTIONS NOBUSY BUSYMESSAGE DC_LangMsg(DCMSG_CLR_WAIT)
DCREAD GUI EXPRESS FIT TO lOk MODAL ;
   CLEAREVENTS ;
   TITLE cTitle ;
   OPTIONS GetOptions ;
   EVAL {|o|IIF( lRGB,_PaintColors(oStatic),nil), ;
           o:paint := {||IIF(lRGB,_PaintColors(oStatic),nil)},;
           oStatic:paint := {||IIF(lRGB,_PaintColors(oStatic),nil)} }

IF !lOk

  aColorSel := aSaveColor

ELSEIF nMode = 0 .OR. nMode = 1

  IF !lRGB .AND. Empty(aColorSel)
    RETURN nil
  ELSEIF nMode = 1
    IF lRGB
      RETURN '{||{' + Alltrim(Str(nCOLOR_RED_FG)) + ',' + ;
                      Alltrim(Str(nCOLOR_GREEN_FG)) + ',' + ;
                      Alltrim(Str(nCOLOR_BLUE_FG)) + '},{' + ;
                      Alltrim(Str(nCOLOR_RED_BG)) + ',' + ;
                      Alltrim(Str(nCOLOR_GREEN_BG)) + ',' + ;
                      Alltrim(Str(nCOLOR_BLUE_BG)) + '} }'
    ELSE
      RETURN '{||{'+Alltrim(Str(aColorSel[1]))+','+Alltrim(Str(aColorSel[2]))+'}}'
    ENDIF
  ELSE
    IF lRGB
      aColorSel := { { nCOLOR_RED_FG, nCOLOR_GREEN_FG, nCOLOR_BLUE_FG }, ;
                     { nCOLOR_RED_BG, nCOLOR_GREEN_BG, nCOLOR_BLUE_BG } }
    ENDIF
    RETURN aColorSel
  ENDIF
ELSEIF nMode = 2
  IF lRGB
    RETURN { nCOLOR_RED_BG, nCOLOR_GREEN_BG, nCOLOR_BLUE_BG }
  ELSE
    RETURN aColorSel
  ENDIF
ENDIF

RETURN aColorSel

* -------------------

STATIC FUNCTION _PaintColors( oStatic )

LOCAL i, aAttr, oPS := oStatic:LockPS()

FOR i := 0 TO 255
   aAttr := Array(GRA_AA_COUNT)
   aAttr[GRA_AA_COLOR] := GraMakeRGBColor({i,0,0})
   GraSetAttrArea( oPS, aAttr )
   GraBox( oPS, {i*2,40}, {(i*2)+1,59}, GRA_FILL, nil, nil )
   aAttr[GRA_AA_COLOR] := GraMakeRGBColor({0,i,0})
   GraSetAttrArea( oPS, aAttr )
   GraBox( oPS, {i*2,20}, {(i*2)+1,39}, GRA_FILL, nil, nil )
   aAttr[GRA_AA_COLOR] := GraMakeRGBColor({0,0,i})
   GraSetAttrArea( oPS, aAttr )
   GraBox( oPS, {i*2,0}, {(i*2)+1,19}, GRA_FILL, nil, nil )
NEXT
oStatic:unlockPS(oPS)

RETURN nil

* -------------------

STATIC FUNCTION _RGB( aRGB, mp1, mp2, oStatic )

LOCAL nWhich, nColor

IF mp2[2] > 39
  nWhich := 1
ELSEIF mp2[2] > 19
  nWhich := 2
ELSE
  nWhich := 3
ENDIF

nColor := Int(mp2[1]/2)
IF nColor > 255
  nColor := 255
ENDIF

IF lCOLOR_FOREGROUND .AND. nWhich = 1
  nCOLOR_RED_FG := nColor
ELSEIF lCOLOR_FOREGROUND .AND. nWhich = 2
  nCOLOR_GREEN_FG := nColor
ELSEIF lCOLOR_FOREGROUND .AND. nWhich = 3
  nCOLOR_BLUE_FG := nColor
ELSEIF !lCOLOR_FOREGROUND .AND. nWhich = 1
  nCOLOR_RED_BG := nColor
ELSEIF !lCOLOR_FOREGROUND .AND. nWhich = 2
  nCOLOR_GREEN_BG := nColor
ELSEIF !lCOLOR_FOREGROUND .AND. nWhich = 3
  nCOLOR_BLUE_BG := nColor
ENDIF

oCOLOR_RGB:setColorFG( GraMakeRGBColor({nCOLOR_RED_FG,nCOLOR_GREEN_FG,nCOLOR_BLUE_FG}) )
oCOLOR_RGB:setColorBG( GraMakeRGBColor({nCOLOR_RED_BG,nCOLOR_GREEN_BG,nCOLOR_BLUE_BG}) )
IF Valtype(oCOLOR_RED_FG) = 'O'
  oCOLOR_RED_FG:setCaption(Alltrim(Str(nCOLOR_RED_FG)))
  oCOLOR_GREEN_FG:setCaption(Alltrim(Str(nCOLOR_GREEN_FG)))
  oCOLOR_BLUE_FG:setCaption(Alltrim(Str(nCOLOR_BLUE_FG)))
ENDIF
oCOLOR_RED_BG:setCaption(Alltrim(Str(nCOLOR_RED_BG)))
oCOLOR_GREEN_BG:setCaption(Alltrim(Str(nCOLOR_GREEN_BG)))
oCOLOR_BLUE_BG:setCaption(Alltrim(Str(nCOLOR_BLUE_BG)))

RETURN nil

